import 'package:example/demos/v_popu/popu_demos/dropdown_menu.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:v_base_framework/page/base_page.dart';
import 'package:v_base_framework/widget/appbar_helper.dart';
import 'package:v_components/widgets/button/grident_button.dart';
import 'package:v_components/widgets/popu/v_popup.dart';
import 'package:v_base_framework/utils/colors_util.dart';

import 'popu_demos/guide_popu.dart';
import 'popu_demos/logout.dart';

class VPopuDemo extends BasePage {
  @override
  CommonBasePageState<BasePage> createBaseState() => _CellState();
}

class _CellState extends CommonBasePageState<VPopuDemo> {
  GlobalKey key1 = GlobalKey(),
      key2 = GlobalKey(),
      key3 = GlobalKey(),
      key4 = GlobalKey();

  @override
  void initBaseParams() {}

  @override
  void initPageData() {}

  @override
  Widget buildPageWidget(BuildContext context) {
    return Scaffold(
        appBar: CommonAppbarUtil.getAppBar(
          context,
          appBarBackgroundColor: "#0057bf", //1bbbf2
          title: "VPopu",
        ),
        body: SizedBox(
          width: double.infinity,
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              const SizedBox(
                height: 50,
              ),
              VButton(
                  key: key1,
                  onPressed: () => _showDropDownMenu(),
                  width: 300,
                  color: ColorsUtil.hex2Color("#0389fa"),
                  child: const Text(
                    "弹出位置更改",
                    style: TextStyle(color: Colors.white, fontSize: 15),
                  )),
              const SizedBox(
                height: 50,
              ),
              VButton(
                  key: key2,
                  onPressed: () => _showGuidePopup(),
                  width: 300,
                  color: ColorsUtil.hex2Color("#0389fa"),
                  child: const Text(
                    "一步步引导",
                    style: TextStyle(color: Colors.white, fontSize: 15),
                  )),
              const SizedBox(
                height: 50,
              ),
              VButton(
                  key: key3,
                  width: 300,
                  color: ColorsUtil.hex2Color("#0389fa"),
                  onPressed: () => _showMultiHighlightsGuidePopup(),
                  child: const Text(
                    "自定义按钮",
                    style: TextStyle(color: Colors.white, fontSize: 15),
                  )),
              const SizedBox(
                height: 50,
              ),
              VButton(
                  key: key4,
                  onPressed: () => _showLogoutPopu(),
                  width: 300,
                  color: ColorsUtil.hex2Color("#0389fa"),
                  child: const Text(
                    "中间弹框",
                    style: TextStyle(color: Colors.white, fontSize: 15),
                  )),
            ],
          ),
        ));
  }

  _showDropDownMenu() {
    DropDownMenu _dropDownMenu = DropDownMenu();
    VPopup.show(context, _dropDownMenu,
        offsetLT: Offset(0, MediaQuery.of(context).padding.top + 50),
        onPopupDismiss: () {
      _dropDownMenu.dismiss();
    });
  }

  _showLogoutPopu() {
    VPopup.show(
      context,
      LogoutPopu(), /* darkEnable: false, */
    );

//     Future.delayed(const Duration(milliseconds: 5000), () {
// EasyPopup.pop(context);

// });
  }

  _showGuidePopup() {
    RenderBox box = key1.currentContext?.findRenderObject() as RenderBox;
    Offset offset = box.localToGlobal(Offset.zero);
    double left = offset.dx - 5;
    double top = offset.dy - 5;
    double width = box.size.width + 10;
    double height = box.size.height + 10;
    List<RRect> highlights = [
      RRect.fromRectAndRadius(
        Rect.fromLTWH(left, top, width, height),
        const Radius.circular(10),
      ),
    ];
    VPopup.show(
      context,
      GuidePopup([key1, key2, key3, key4]),
      cancelable: false,
      highlights: highlights,
      duration: const Duration(milliseconds: 100),
    );
  }

  _showMultiHighlightsGuidePopup() {
    List<GlobalKey> keys = [key1, key2, key3, key4];
    List<RRect> highlights = [];
    for (GlobalKey key in keys) {
      RenderBox box = key.currentContext?.findRenderObject() as RenderBox;
      Offset offset = box.localToGlobal(Offset.zero);
      double left = offset.dx - 5;
      double top = offset.dy - 5;
      double width = box.size.width + 10;
      double height = box.size.height + 10;
      highlights.add(
        RRect.fromRectAndRadius(
          Rect.fromLTWH(left, top, width, height),
          const Radius.circular(10),
        ),
      );
    }
    VPopup.show(
      context,
      GuidePopup([key1]),
      cancelable: false,
      highlights: highlights,
      duration: const Duration(milliseconds: 100),
    );
  }
}
