import 'package:flutter/material.dart';

import 'v_popup_route.dart';

class VPopup {
  ///Dismiss the popup related to the specific BuildContext
  static pop(BuildContext context) {
    VPopupRoute.pop(context);
  }

  ///Show popup
  static show(
    BuildContext context,
    Widget child, {
    Offset? offsetLT,
    Offset? offsetRB,
    bool cancelable = true,
    bool outsideTouchCancelable = true,
    double? opacity,
    Duration duration =
        const Duration(milliseconds: 30), //当做dialog使用的时候会有消失的延迟，所有这个给成不可设置
    List<RRect>? highlights,
    VoidCallback? onPopupShow,
    VoidCallback? onPopupDismiss,
  }) {
    Navigator.of(context).push(
      VPopupRoute(
          child: child,
          offsetLT: offsetLT,
          offsetRB: offsetRB,
          cancelable: cancelable,
          outsideTouchCancelable: outsideTouchCancelable,
          duration: duration,
          highlights: highlights,
          opacity: opacity ?? 0.6,
          onPopupShow: onPopupShow,
          onPopupDismiss: onPopupDismiss),
    );
  }

  ///Set popup highlight positions
  static setHighlights(BuildContext context, List<RRect> highlights) {
    VPopupRoute.setHighlights(context, highlights);
  }
}
